////////////////////////////////////////////////////////
//SimplexNoise Beispiel: Berg-Landschaft
////////////////////////////////////////////////////////
import toxi.math.noise.*;

PImage bild;
float[][]hoehe = new float[500][500]; //Matrix für die Höhen
float tempNoise =0.0;
float xN,yN;
float w, sW;

void setup() {
  size(900, 900, P3D);
  //Gut geeignet sind Luftaufnahmen mit 500x500 Auflösung
  bild = loadImage("bild.jpg");  //Textur
  smooth();
  xN=random(0.6,1.4);//Damit sehen die Bilder... 
  yN=random(0.6,1.4);//nicht immer gleich aus.
  w=0.001;sW=0;
}

void draw() {
  background(0,0,200); //Himmel
  if(sW<0.6){
    sW= sW+w;
  }else sW =0;
  rotateX(1);
  rotateZ(sW);//z-Achse, wegen Drehung um x-Achse um 1 (knapp 60 Grad)
  berge(); 
}

void berge() {
  translate(0,0, -200); 
  float w = 2; //QUAD Weite
  float h = 2; //QUAD Höhe
  float maxHoehe = 150; //maximale Höhe der Berge
  float wellenL = 150; 
  for (int i = 0; i < 500; i++) {
    for (int j = 0; j < 500; j++) {
      tempNoise = (float)SimplexNoise.noise(xN*float(i)/wellenL, yN*float(j)/wellenL);
      tempNoise = map(tempNoise,-1,1,0,1);//Wertebereich von [-1;1] auf [0;1] ändern
      hoehe[i][j] = tempNoise*maxHoehe;
    }
  }
  for (int x = 0; x < 499; x++) {
    for (int y = 0; y < 499; y++) {
      beginShape(QUADS);
         noStroke();
         if(hoehe[x][y]>30){
           //Textur aus Bild
           fill(bild.pixels[x+y*500]);
         } 
         //Seen in den Tälern
         if(hoehe[x][y]<=30){  
           fill(0,hoehe[x][y],3*hoehe[x][y]); 
         }          
        vertex(x*w , y*h, hoehe[x][y] );
        vertex((x+1)*w ,y*h, hoehe[x+1][y]);
        vertex((x+1)*w ,(y+1)*h , hoehe[x+1][y+1] );
        vertex(x*w , (y+1)*h, hoehe[x][y+1] );//daher maximale x und y: 499
      endShape();
    }
  }
}